#pragma once

#include <Arduino.h>
#include <SoftwareSerial.h>
#include "Config.h"
#include "Packet.h"

// Kommunikation mit dem PC.
class PcPortClass {
public:    
   void init();              // Initialisiert die (serielle) Schnittstelle.
   int readPacket();         // Wartet auf den Empfang eines Pakets. Liefert die Anzahl eingelesener Bytes, negative Werte: Fehler.
                             // Auf die empfangenen Bytes kann ber das Feld 'packet' zugegriffen werden.
   void sendResultPacket();  // Sendet Testergebnisse, verschiedene Packet-Typen. Vor dem Versand wird die CRC berechnet.
   void sendOK();           // Sendet positives Quittungspaket.
   void sendBadPacketType(); // Sendet Fehlerpaket: ungltiger Pakettyp.
   void sendBadCrc();        // Sendet Fehlerpaket: ungltige CRC.
   void sendBadPinType();    // Sendet Fehlerpaket: ungltiger Pin-Typ.

   // I2C-Kommunikation mit einem I2C-Slave im Test
   void sendBadI2CPins();    // SDA oder SCL sind ungltig oder nicht gesetzt.
   void sendI2cNack();       // Der Slave hat mit NACK geantwortet.
   void sendI2cInvalidAdress(); // Kein Slave hat auf die Adresse reagiert.
   void sendI2cIoError();    // Fehler bei der Datenbertragung (timeout, ost bus arbitration, bus error, ...).
   void sendi2cBeginError(); // Kontrolle ber den BUS kann nicht bernommen werden.
};

extern PcPortClass PcPort;