﻿using IC_DB;

namespace IC_Tester_Controls
{
   internal class IcListBox : ListBox
   {
      // Overrides the parent class Sort to perform a simple
      // bubble sort on the length of the string contained in each item.
      protected override void Sort()
      {
         if (Items.Count > 1)
         {
            bool swapped;
            do
            {
               int counter = Items.Count - 1;
               swapped = false;

               while (counter > 0)
               {
                  // Compare the items
                  var o1 = (IcDefinition)Items[counter];
                  var o2 = (IcDefinition)Items[counter - 1];

                  if (o1.NameCompare(o2) < 0)
                  {
                     // Swap the items.
                     object temp = Items[counter];
                     Items[counter] = Items[counter - 1];
                     Items[counter - 1] = temp;
                     swapped = true;
                  }
                  // Decrement the counter.
                  counter -= 1;
               }
            }
            while ((swapped == true));
         }
      }
   }
}
